#include <windows.h>
#include <commctrl.h>
#include "resource.h"

#include <psapi.h>

#define halloc(s) HeapAlloc(GetProcessHeap(), 0, s)
#define hfree(p) HeapFree(GetProcessHeap(), 0, p)

/*

	Most referenced:
	The Code Project - Custom draw TreeView (A companion to my Sorted ListView control) - C# Controls
		http://web.archive.org/web/20030224185941/http://www.codeproject.com/cs/miscctrl/treeview.asp
		From:
		ĂσuO
			http://d.hatena.ne.jp/nitoyon/20040916

	Referenced:
	The Code Project - C# Sorted ListView - C# Controls
		http://web.archive.org/web/20030304203316/http://thecodeproject.com/cs/miscctrl/sortedlistview.asp
		From:
		ĂσuO
			(see above)
	CodeGuru: Setting color and font attribute for individual items
		http://www.codeguru.com/Cpp/controls/treeview/misc-advanced/article.php/c633#more
		From:
		Google
			(As you know)


	Thanks for shareing techniques!

*/

struct tagWMessages{
	UINT msg;
	LPCTSTR name;
	LPCTSTR desc;
} WMessages[] = {
	WM_NULL,					TEXT("WM_NULL"),					TEXT("ȂɂȂ"),
	WM_CREATE,					TEXT("WM_CREATE"),					TEXT(""),
	WM_DESTROY,					TEXT("WM_DESTROY"),					TEXT(""),
	WM_MOVE,					TEXT("WM_MOVE"),					TEXT("ړ"),
	WM_SIZE,					TEXT("WM_SIZE"),					TEXT("TCY"),
	WM_ACTIVATE,				TEXT("WM_ACTIVATE"),				TEXT(""),
	WM_SETFOCUS,				TEXT("WM_SETFOCUS"),				TEXT(""),
	WM_KILLFOCUS,				TEXT("WM_KILLFOCUS"),				TEXT(""),
	WM_ENABLE,					TEXT("WM_ENABLE"),					TEXT("L/̐ݒ"),
	WM_SETREDRAW,				TEXT("WM_SETREDRAW"),				TEXT(""),
	WM_SETTEXT,					TEXT("WM_SETTEXT"),					TEXT(""),
	WM_GETTEXT,					TEXT("WM_GETTEXT"),					TEXT(""),
	WM_GETTEXTLENGTH,			TEXT("WM_GETTEXTLENGTH"),			TEXT(""),
	WM_PAINT,					TEXT("WM_PAINT"),					TEXT(""),
	WM_CLOSE,					TEXT("WM_CLOSE"),					TEXT(""),
	WM_QUERYENDSESSION,			TEXT("WM_QUERYENDSESSION"),			TEXT(""),
	WM_QUERYOPEN,				TEXT("WM_QUERYOPEN"),				TEXT(""),
	WM_ENDSESSION,				TEXT("WM_ENDSESSION"),				TEXT(""),
	WM_QUIT,					TEXT("WM_QUIT"),					TEXT(""),
	WM_ERASEBKGND,				TEXT("WM_ERASEBKGND"),				TEXT(""),
	WM_SYSCOLORCHANGE,			TEXT("WM_SYSCOLORCHANGE"),			TEXT(""),
	WM_SHOWWINDOW,				TEXT("WM_SHOWWINDOW"),				TEXT(""),
	WM_WININICHANGE,			TEXT("WM_WININICHANGE"),			TEXT(""),
	WM_DEVMODECHANGE,			TEXT("WM_DEVMODECHANGE"),			TEXT(""),
	WM_ACTIVATEAPP,				TEXT("WM_ACTIVATEAPP"),				TEXT(""),
	WM_FONTCHANGE,				TEXT("WM_FONTCHANGE"),				TEXT(""),
	WM_TIMECHANGE,				TEXT("WM_TIMECHANGE"),				TEXT(""),
	WM_CANCELMODE,				TEXT("WM_CANCELMODE"),				TEXT(""),
	WM_SETCURSOR,				TEXT("WM_SETCURSOR"),				TEXT(""),
	WM_MOUSEACTIVATE,			TEXT("WM_MOUSEACTIVATE"),			TEXT(""),
	WM_CHILDACTIVATE,			TEXT("WM_CHILDACTIVATE"),			TEXT(""),
	WM_QUEUESYNC,				TEXT("WM_QUEUESYNC"),				TEXT(""),
	WM_GETMINMAXINFO,			TEXT("WM_GETMINMAXINFO"),			TEXT(""),
	WM_PAINTICON,				TEXT("WM_PAINTICON"),				TEXT(""),
	WM_ICONERASEBKGND,			TEXT("WM_ICONERASEBKGND"),			TEXT(""),
	WM_NEXTDLGCTL,				TEXT("WM_NEXTDLGCTL"),				TEXT(""),
	WM_SPOOLERSTATUS,			TEXT("WM_SPOOLERSTATUS"),			TEXT(""),
	WM_DRAWITEM,				TEXT("WM_DRAWITEM"),				TEXT(""),
	WM_MEASUREITEM,				TEXT("WM_MEASUREITEM"),				TEXT(""),
	WM_DELETEITEM,				TEXT("WM_DELETEITEM"),				TEXT(""),
	WM_VKEYTOITEM,				TEXT("WM_VKEYTOITEM"),				TEXT(""),
	WM_CHARTOITEM,				TEXT("WM_CHARTOITEM"),				TEXT(""),
	WM_SETFONT,					TEXT("WM_SETFONT"),					TEXT(""),
	WM_GETFONT,					TEXT("WM_GETFONT"),					TEXT(""),
	WM_SETHOTKEY,				TEXT("WM_SETHOTKEY"),				TEXT(""),
	WM_GETHOTKEY,				TEXT("WM_GETHOTKEY"),				TEXT(""),
	WM_QUERYDRAGICON,			TEXT("WM_QUERYDRAGICON"),			TEXT(""),
	WM_COMPAREITEM,				TEXT("WM_COMPAREITEM"),				TEXT(""),
	WM_GETOBJECT,				TEXT("WM_GETOBJECT"),				TEXT(""),
	WM_COMPACTING,				TEXT("WM_COMPACTING"),				TEXT(""),
	WM_WINDOWPOSCHANGING,		TEXT("WM_WINDOWPOSCHANGING"),		TEXT(""),
	WM_WINDOWPOSCHANGED,		TEXT("WM_WINDOWPOSCHANGED"),		TEXT(""),
	WM_POWER,					TEXT("WM_POWER"),					TEXT(""),
	WM_COPYDATA,				TEXT("WM_COPYDATA"),				TEXT(""),
	WM_CANCELJOURNAL,			TEXT("WM_CANCELJOURNAL"),			TEXT(""),
	WM_NOTIFY,					TEXT("WM_NOTIFY"),					TEXT(""),
	WM_INPUTLANGCHANGEREQUEST,	TEXT("WM_INPUTLANGCHANGEREQUEST"),	TEXT(""),
	WM_INPUTLANGCHANGE,			TEXT("WM_INPUTLANGCHANGE"),			TEXT(""),
	WM_TCARD,					TEXT("WM_TCARD"),					TEXT(""),
	WM_HELP,					TEXT("WM_HELP"),					TEXT(""),
	WM_USERCHANGED,				TEXT("WM_USERCHANGED"),				TEXT(""),
	WM_NOTIFYFORMAT,			TEXT("WM_NOTIFYFORMAT"),			TEXT(""),
	WM_CONTEXTMENU,				TEXT("WM_CONTEXTMENU"),				TEXT("V[gJbgj[̕\"),
	WM_STYLECHANGING,			TEXT("WM_STYLECHANGING"),			TEXT(""),
	WM_STYLECHANGED,			TEXT("WM_STYLECHANGED"),			TEXT(""),
	WM_DISPLAYCHANGE,			TEXT("WM_DISPLAYCHANGE"),			TEXT(""),
	WM_GETICON,					TEXT("WM_GETICON"),					TEXT(""),
	WM_SETICON,					TEXT("WM_SETICON"),					TEXT(""),
	WM_NCCREATE,				TEXT("WM_NCCREATE"),				TEXT(""),
	WM_NCDESTROY,				TEXT("WM_NCDESTROY"),				TEXT(""),
	WM_NCCALCSIZE,				TEXT("WM_NCCALCSIZE"),				TEXT(""),
	WM_NCHITTEST,				TEXT("WM_NCHITTEST"),				TEXT(""),
	WM_NCPAINT,					TEXT("WM_NCPAINT"),					TEXT(""),
	WM_NCACTIVATE,				TEXT("WM_NCACTIVATE"),				TEXT(""),
	WM_GETDLGCODE,				TEXT("WM_GETDLGCODE"),				TEXT(""),
	WM_SYNCPAINT,				TEXT("WM_SYNCPAINT"),				TEXT(""),
	WM_NCMOUSEMOVE,				TEXT("WM_NCMOUSEMOVE"),				TEXT(""),
	WM_NCLBUTTONDOWN,			TEXT("WM_NCLBUTTONDOWN"),			TEXT(""),
	WM_NCLBUTTONUP,				TEXT("WM_NCLBUTTONUP"),				TEXT(""),
	WM_NCLBUTTONDBLCLK,			TEXT("WM_NCLBUTTONDBLCLK"),			TEXT(""),
	WM_NCRBUTTONDOWN,			TEXT("WM_NCRBUTTONDOWN"),			TEXT(""),
	WM_NCRBUTTONUP,				TEXT("WM_NCRBUTTONUP"),				TEXT(""),
	WM_NCRBUTTONDBLCLK,			TEXT("WM_NCRBUTTONDBLCLK"),			TEXT(""),
	WM_NCMBUTTONDOWN,			TEXT("WM_NCMBUTTONDOWN"),			TEXT(""),
	WM_NCMBUTTONUP,				TEXT("WM_NCMBUTTONUP"),				TEXT(""),
	WM_NCMBUTTONDBLCLK,			TEXT("WM_NCMBUTTONDBLCLK"),			TEXT(""),
/*
	WM_NCXBUTTONDOWN,			TEXT("WM_NCXBUTTONDOWN"),			TEXT(""),
	WM_NCXBUTTONUP,				TEXT("WM_NCXBUTTONUP"),				TEXT(""),
	WM_NCXBUTTONDBLCLK,			TEXT("WM_NCXBUTTONDBLCLK"),			TEXT(""),
	WM_INPUT,					TEXT("WM_INPUT"),					TEXT(""),
*/
	WM_KEYFIRST,				TEXT("WM_KEYFIRST"),				TEXT(""),
	WM_KEYDOWN,					TEXT("WM_KEYDOWN"),					TEXT("L[ꂽ"),
	WM_KEYUP,					TEXT("WM_KEYUP"),					TEXT("L[ꂽ"),
	WM_CHAR,					TEXT("WM_CHAR"),					TEXT(""),
	WM_DEADCHAR,				TEXT("WM_DEADCHAR"),				TEXT(""),
	WM_SYSKEYDOWN,				TEXT("WM_SYSKEYDOWN"),				TEXT(""),
	WM_SYSKEYUP,				TEXT("WM_SYSKEYUP"),				TEXT(""),
	WM_SYSCHAR,					TEXT("WM_SYSCHAR"),					TEXT(""),
	WM_SYSDEADCHAR,				TEXT("WM_SYSDEADCHAR"),				TEXT(""),
/*
	WM_UNICHAR,					TEXT("WM_UNICHAR"),					TEXT(""),
*/
	WM_KEYLAST,					TEXT("WM_KEYLAST"),					TEXT(""),
	WM_KEYLAST,					TEXT("WM_KEYLAST"),					TEXT(""),
	WM_IME_STARTCOMPOSITION,	TEXT("WM_IME_STARTCOMPOSITION"),	TEXT(""),
	WM_IME_ENDCOMPOSITION,		TEXT("WM_IME_ENDCOMPOSITION"),		TEXT(""),
	WM_IME_COMPOSITION,			TEXT("WM_IME_COMPOSITION"),			TEXT(""),
	WM_IME_KEYLAST,				TEXT("WM_IME_KEYLAST"),				TEXT(""),
	WM_INITDIALOG,				TEXT("WM_INITDIALOG"),				TEXT(""),
	WM_COMMAND,					TEXT("WM_COMMAND"),					TEXT("j[{^Ȃ"),
	WM_SYSCOMMAND,				TEXT("WM_SYSCOMMAND"),				TEXT("VXej[֘A"),
	WM_TIMER,					TEXT("WM_TIMER"),					TEXT("^C}["),
	WM_HSCROLL,					TEXT("WM_HSCROLL"),					TEXT(""),
	WM_VSCROLL,					TEXT("WM_VSCROLL"),					TEXT(""),
	WM_INITMENU,				TEXT("WM_INITMENU"),				TEXT(""),
	WM_INITMENUPOPUP,			TEXT("WM_INITMENUPOPUP"),			TEXT(""),
	WM_MENUSELECT,				TEXT("WM_MENUSELECT"),				TEXT(""),
	WM_MENUCHAR,				TEXT("WM_MENUCHAR"),				TEXT(""),
	WM_ENTERIDLE,				TEXT("WM_ENTERIDLE"),				TEXT(""),
	WM_MENURBUTTONUP,			TEXT("WM_MENURBUTTONUP"),			TEXT(""),
	WM_MENUDRAG,				TEXT("WM_MENUDRAG"),				TEXT(""),
	WM_MENUGETOBJECT,			TEXT("WM_MENUGETOBJECT"),			TEXT(""),
	WM_UNINITMENUPOPUP,			TEXT("WM_UNINITMENUPOPUP"),			TEXT(""),
	WM_MENUCOMMAND,				TEXT("WM_MENUCOMMAND"),				TEXT(""),
/*
	WM_CHANGEUISTATE,			TEXT("WM_CHANGEUISTATE"),			TEXT(""),
	WM_UPDATEUISTATE,			TEXT("WM_UPDATEUISTATE"),			TEXT(""),
	WM_QUERYUISTATE,			TEXT("WM_QUERYUISTATE"),			TEXT(""),
*/
	WM_CTLCOLORMSGBOX,			TEXT("WM_CTLCOLORMSGBOX"),			TEXT(""),
	WM_CTLCOLOREDIT,			TEXT("WM_CTLCOLOREDIT"),			TEXT(""),
	WM_CTLCOLORLISTBOX,			TEXT("WM_CTLCOLORLISTBOX"),			TEXT(""),
	WM_CTLCOLORBTN,				TEXT("WM_CTLCOLORBTN"),				TEXT(""),
	WM_CTLCOLORDLG,				TEXT("WM_CTLCOLORDLG"),				TEXT(""),
	WM_CTLCOLORSCROLLBAR,		TEXT("WM_CTLCOLORSCROLLBAR"),		TEXT(""),
	WM_CTLCOLORSTATIC,			TEXT("WM_CTLCOLORSTATIC"),			TEXT(""),
	WM_MOUSEFIRST,				TEXT("WM_MOUSEFIRST"),				TEXT(""),
	WM_MOUSEMOVE,				TEXT("WM_MOUSEMOVE"),				TEXT(""),
	WM_LBUTTONDOWN,				TEXT("WM_LBUTTONDOWN"),				TEXT("LMBꂽ"),
	WM_LBUTTONUP,				TEXT("WM_LBUTTONUP"),				TEXT("LMBꂽ"),
	WM_LBUTTONDBLCLK,			TEXT("WM_LBUTTONDBLCLK"),			TEXT("LMBŃ_uNbN"),
	WM_RBUTTONDOWN,				TEXT("WM_RBUTTONDOWN"),				TEXT("RMBꂽ"),
	WM_RBUTTONUP,				TEXT("WM_RBUTTONUP"),				TEXT("RMBꂽ"),
	WM_RBUTTONDBLCLK,			TEXT("WM_RBUTTONDBLCLK"),			TEXT("RMBŃ_uNbN"),
	WM_MBUTTONDOWN,				TEXT("WM_MBUTTONDOWN"),				TEXT("MMBꂽ"),
	WM_MBUTTONUP,				TEXT("WM_MBUTTONUP"),				TEXT("MMBꂽ"),
	WM_MBUTTONDBLCLK,			TEXT("WM_MBUTTONDBLCLK"),			TEXT("MMBŃ_uNbN"),
/*
	WM_MOUSEWHEEL,				TEXT("WM_MOUSEWHEEL"),				TEXT(""),
	WM_XBUTTONDOWN,				TEXT("WM_XBUTTONDOWN"),				TEXT(""),
	WM_XBUTTONUP,				TEXT("WM_XBUTTONUP"),				TEXT(""),
	WM_XBUTTONDBLCLK,			TEXT("WM_XBUTTONDBLCLK"),			TEXT(""),
	WM_MOUSELAST,				TEXT("WM_MOUSELAST"),				TEXT(""),
	WM_MOUSELAST,				TEXT("WM_MOUSELAST"),				TEXT(""),
*/
	WM_MOUSELAST,				TEXT("WM_MOUSELAST"),				TEXT(""),
	WM_PARENTNOTIFY,			TEXT("WM_PARENTNOTIFY"),			TEXT(""),
	WM_ENTERMENULOOP,			TEXT("WM_ENTERMENULOOP"),			TEXT(""),
	WM_EXITMENULOOP,			TEXT("WM_EXITMENULOOP"),			TEXT(""),
	WM_NEXTMENU,				TEXT("WM_NEXTMENU"),				TEXT(""),
	WM_SIZING,					TEXT("WM_SIZING"),					TEXT(""),
	WM_CAPTURECHANGED,			TEXT("WM_CAPTURECHANGED"),			TEXT(""),
	WM_MOVING,					TEXT("WM_MOVING"),					TEXT(""),
	WM_POWERBROADCAST,			TEXT("WM_POWERBROADCAST"),			TEXT(""),
	WM_DEVICECHANGE,			TEXT("WM_DEVICECHANGE"),			TEXT(""),
	WM_MDICREATE,				TEXT("WM_MDICREATE"),				TEXT(""),
	WM_MDIDESTROY,				TEXT("WM_MDIDESTROY"),				TEXT(""),
	WM_MDIACTIVATE,				TEXT("WM_MDIACTIVATE"),				TEXT(""),
	WM_MDIRESTORE,				TEXT("WM_MDIRESTORE"),				TEXT(""),
	WM_MDINEXT,					TEXT("WM_MDINEXT"),					TEXT(""),
	WM_MDIMAXIMIZE,				TEXT("WM_MDIMAXIMIZE"),				TEXT(""),
	WM_MDITILE,					TEXT("WM_MDITILE"),					TEXT(""),
	WM_MDICASCADE,				TEXT("WM_MDICASCADE"),				TEXT(""),
	WM_MDIICONARRANGE,			TEXT("WM_MDIICONARRANGE"),			TEXT(""),
	WM_MDIGETACTIVE,			TEXT("WM_MDIGETACTIVE"),			TEXT(""),
	WM_MDISETMENU,				TEXT("WM_MDISETMENU"),				TEXT(""),
	WM_ENTERSIZEMOVE,			TEXT("WM_ENTERSIZEMOVE"),			TEXT(""),
	WM_EXITSIZEMOVE,			TEXT("WM_EXITSIZEMOVE"),			TEXT(""),
	WM_DROPFILES,				TEXT("WM_DROPFILES"),				TEXT(""),
	WM_MDIREFRESHMENU,			TEXT("WM_MDIREFRESHMENU"),			TEXT(""),
	WM_IME_SETCONTEXT,			TEXT("WM_IME_SETCONTEXT"),			TEXT(""),
	WM_IME_NOTIFY,				TEXT("WM_IME_NOTIFY"),				TEXT(""),
	WM_IME_CONTROL,				TEXT("WM_IME_CONTROL"),				TEXT(""),
	WM_IME_COMPOSITIONFULL,		TEXT("WM_IME_COMPOSITIONFULL"),		TEXT(""),
	WM_IME_SELECT,				TEXT("WM_IME_SELECT"),				TEXT(""),
	WM_IME_CHAR,				TEXT("WM_IME_CHAR"),				TEXT(""),
	WM_IME_REQUEST,				TEXT("WM_IME_REQUEST"),				TEXT(""),
	WM_IME_KEYDOWN,				TEXT("WM_IME_KEYDOWN"),				TEXT(""),
	WM_IME_KEYUP,				TEXT("WM_IME_KEYUP"),				TEXT(""),
	WM_MOUSEHOVER,				TEXT("WM_MOUSEHOVER"),				TEXT(""),
	WM_MOUSELEAVE,				TEXT("WM_MOUSELEAVE"),				TEXT(""),
	WM_NCMOUSEHOVER,			TEXT("WM_NCMOUSEHOVER"),			TEXT(""),
	WM_NCMOUSELEAVE,			TEXT("WM_NCMOUSELEAVE"),			TEXT(""),
/*
	WM_WTSSESSION_CHANGE,		TEXT("WM_WTSSESSION_CHANGE"),		TEXT(""),
	WM_TABLET_FIRST,			TEXT("WM_TABLET_FIRST"),			TEXT(""),
	WM_TABLET_LAST,				TEXT("WM_TABLET_LAST"),				TEXT(""),
*/
	WM_CUT,						TEXT("WM_CUT"),						TEXT(""),
	WM_COPY,					TEXT("WM_COPY"),					TEXT(""),
	WM_PASTE,					TEXT("WM_PASTE"),					TEXT(""),
	WM_CLEAR,					TEXT("WM_CLEAR"),					TEXT(""),
	WM_UNDO,					TEXT("WM_UNDO"),					TEXT(""),
	WM_RENDERFORMAT,			TEXT("WM_RENDERFORMAT"),			TEXT(""),
	WM_RENDERALLFORMATS,		TEXT("WM_RENDERALLFORMATS"),		TEXT(""),
	WM_DESTROYCLIPBOARD,		TEXT("WM_DESTROYCLIPBOARD"),		TEXT(""),
	WM_DRAWCLIPBOARD,			TEXT("WM_DRAWCLIPBOARD"),			TEXT(""),
	WM_PAINTCLIPBOARD,			TEXT("WM_PAINTCLIPBOARD"),			TEXT(""),
	WM_VSCROLLCLIPBOARD,		TEXT("WM_VSCROLLCLIPBOARD"),		TEXT(""),
	WM_SIZECLIPBOARD,			TEXT("WM_SIZECLIPBOARD"),			TEXT(""),
	WM_ASKCBFORMATNAME,			TEXT("WM_ASKCBFORMATNAME"),			TEXT(""),
	WM_CHANGECBCHAIN,			TEXT("WM_CHANGECBCHAIN"),			TEXT(""),
	WM_HSCROLLCLIPBOARD,		TEXT("WM_HSCROLLCLIPBOARD"),		TEXT(""),
	WM_QUERYNEWPALETTE,			TEXT("WM_QUERYNEWPALETTE"),			TEXT(""),
	WM_PALETTEISCHANGING,		TEXT("WM_PALETTEISCHANGING"),		TEXT(""),
	WM_PALETTECHANGED,			TEXT("WM_PALETTECHANGED"),			TEXT(""),
	WM_HOTKEY,					TEXT("WM_HOTKEY"),					TEXT(""),
	WM_PRINT,					TEXT("WM_PRINT"),					TEXT(""),
	WM_PRINTCLIENT,				TEXT("WM_PRINTCLIENT"),				TEXT(""),
/*
	WM_APPCOMMAND,				TEXT("WM_APPCOMMAND"),				TEXT(""),
	WM_THEMECHANGED,			TEXT("WM_THEMECHANGED"),			TEXT(""),
*/
	WM_HANDHELDFIRST,			TEXT("WM_HANDHELDFIRST"),			TEXT(""),
	WM_HANDHELDLAST,			TEXT("WM_HANDHELDLAST"),			TEXT(""),
	WM_AFXFIRST,				TEXT("WM_AFXFIRST"),				TEXT(""),
	WM_AFXLAST,					TEXT("WM_AFXLAST"),					TEXT(""),
	WM_PENWINFIRST,				TEXT("WM_PENWINFIRST"),				TEXT(""),
	WM_PENWINLAST,				TEXT("WM_PENWINLAST"),				TEXT(""),
};

LPCTSTR basename(LPCTSTR str)
{
	LPCTSTR last = str;

	while(*str)
	{
		if(*str == TEXT('\\'))
			last = str + 1;
		str = CharNext(str);
	}

	return last;
}

int GetDlgItemNum(HWND hDlg, int nCtlID)
{
	TCHAR str[64];
	int ret = 0;

	GetDlgItemText(hDlg, nCtlID, str, sizeof(str));

	if(str[0] == TEXT('0') && str[1] == TEXT('x'))
	{	// HEX
		LPTSTR p = str + 2;

		while(*p)
		{
			// Need TEXT()?
			if('0' <= *p && *p <= '9')
				ret = (ret << 4) | (*p - '0');
			if('A' <= *p && *p <= 'F')
				ret = (ret << 4) | (*p - 'A' + 10);
			if('a' <= *p && *p <= 'f')
				ret = (ret << 4) | (*p - 'a' + 10);
			p++;
		}

		return ret;
	}

	// TODO: support -nnn
	{
		// OCT
		LPTSTR p = str;
		while(*p)
		{
			// Need TEXT()?
			if('0' <= *p && *p <= '9')
				ret = ret * 10 + (*p - '0');
			p++;
		}

		return ret;
	}

	return 0;
}

void waku(HWND hWnd)
{
	HDC hdc;
	HBRUSH holdbrs;
	HPEN holdpen;
	RECT rc;

	GetWindowRect(hWnd, &rc);
	hdc = GetWindowDC(hWnd);
	SetROP2(hdc, R2_NOT);

	holdpen = SelectObject(hdc, CreatePen(PS_INSIDEFRAME, 5, RGB(0, 0, 0)));
	holdbrs = SelectObject(hdc, GetStockObject(NULL_BRUSH));

	Rectangle(hdc, 0, 0, rc.right - rc.left, rc.bottom - rc.top);

	SelectObject(hdc, holdpen);
	SelectObject(hdc, holdbrs);

	ReleaseDC(hWnd, hdc);

	return;
}

void AddWindowRecursive(HWND hTreeWnd, HTREEITEM hParentItem, HWND hWnd)
{
	// Text̓L[{[h̓opɎgB
	TV_INSERTSTRUCT tvis;
	TCHAR tx[32];
	HTREEITEM hti;

	tvis.hParent = hParentItem;
	tvis.hInsertAfter = TVI_LAST;
	tvis.item.mask = TVIF_TEXT | TVIF_PARAM;

	while(hWnd)
	{
		GetWindowText(hWnd, tx, sizeof(tx));
		tvis.item.pszText = tx;
		tvis.item.lParam = (LPARAM)hWnd;
		hti = TreeView_InsertItem(hTreeWnd, &tvis);

		if(GetWindow(hWnd, GW_CHILD))
			AddWindowRecursive(hTreeWnd, hti, GetWindow(hWnd, GW_CHILD));

		// TODO: whileŏ\ X^bNg
		hWnd = GetWindow(hWnd, GW_HWNDNEXT);
	}

	return;
}

/*
void DeleteWindowRecursive(HWND hTreeWnd, HTREEITEM hItem)
{
	if(TreeView_GetChild(hTreeWnd, hItem))
		DeleteWindowRecursive(hTreeWnd, TreeView_GetChild(hTreeWnd, hItem));

	while(hItem)
	{
		TV_ITEM tvi;
		HTREEITEM hnext;

		tvi.mask = TVIF_PARAM;
		tvi.lParam = 0;

		TreeView_GetItem(hTreeWnd, hItem);

		if(tvi.lParam)
			hfree((void*)tvi.lParam);

		hnext = TreeView_GetNextSibling(hTreeWnd, hItem);
		TreeView_DeleteItem(hTreeWnd, hItem);

		hItem = hnext;
	}

	return;
}
*/

LRESULT CALLBACK TreeViewSubProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_APP:
		SetWindowLong(hWnd, GWL_USERDATA, GetWindowLong(hWnd, GWL_WNDPROC));
		SetWindowLong(hWnd, GWL_WNDPROC, (LONG)TreeViewSubProc);
		break;
	case WM_LBUTTONDOWN:
		{
			HD_ITEM hdi;
			int w = 0,i;

			hdi.mask = HDI_WIDTH;

			for(i = 0; i < Header_GetItemCount(GetDlgItem(GetParent(hWnd), IDC_WNDTREEHEADER)); i++)
			{
				Header_GetItem(GetDlgItem(GetParent(hWnd), IDC_WNDTREEHEADER), i, &hdi);
				w += hdi.cxy;
			}

			if(w < LOWORD(lParam))
			{
				//TreeView_SelectItem(hWnd, NULL);
				break;
			}
		}

		{
			//HTREEITEM hti;

			//hti = TreeView_GetFirstVisible(hWnd);

			//while(hti)
			//{
				TV_HITTESTINFO hi;

				hi.pt.x = LOWORD(lParam);
				hi.pt.y = HIWORD(lParam);
				hi.hItem = NULL;//hti;

				TreeView_HitTest(hWnd, &hi);
				if(hi.flags == TVHT_ONITEMRIGHT)	// ONLY ITEMRIGHT!!
				{
					TreeView_SelectItem(hWnd, hi.hItem);
					break;
				}

			//	hti = TreeView_GetNextVisible(hWnd, hti);
			//}
		}
		break;
	case WM_LBUTTONDBLCLK:
		{
			HD_ITEM hdi;
			int w = 0,i;

			hdi.mask = HDI_WIDTH;

			for(i = 0; i < Header_GetItemCount(GetDlgItem(GetParent(hWnd), IDC_WNDTREEHEADER)); i++)
			{
				Header_GetItem(GetDlgItem(GetParent(hWnd), IDC_WNDTREEHEADER), i, &hdi);
				w += hdi.cxy;
			}

			if(w < LOWORD(lParam))
				break;
		}

		{
			HTREEITEM hti;

			hti = TreeView_GetFirstVisible(hWnd);

			while(hti)
			{
				TV_HITTESTINFO hi;

				hi.pt.x = LOWORD(lParam);
				hi.pt.y = HIWORD(lParam);
				hi.hItem = hti;

				TreeView_HitTest(hWnd, &hi);
				if(hi.flags == TVHT_ONITEMRIGHT)	// ONLY ITEMRIGHT!!
				{
					TreeView_Expand(hWnd, hi.hItem, TVE_TOGGLE);
					break;
				}

				hti = TreeView_GetNextVisible(hWnd, hti);
			}
		}
		break;
	}

	return CallWindowProc((WNDPROC)GetWindowLong(hWnd, GWL_USERDATA), hWnd, msg, wParam, lParam);
}

HTREEITEM TVFindItemParam(HWND hTreeWnd, HTREEITEM hFirst, LPARAM lParam)
{
	HTREEITEM hti;

	hti = hFirst;

	while(hti)
	{
		TV_ITEM tvi;

		tvi.mask = TVIF_PARAM;
		tvi.hItem = hti;

		if(!TreeView_GetItem(hTreeWnd, &tvi))
			_asm int 3;

		if(tvi.lParam == lParam)
			return hti;

		if(TreeView_GetChild(hTreeWnd, hti))
		{
			HTREEITEM ret;

			ret = TVFindItemParam(hTreeWnd, TreeView_GetChild(hTreeWnd, hti), lParam);

			if(ret)
				return ret;
		}

		hti = TreeView_GetNextSibling(hTreeWnd, hti);
	}

	return NULL;
}

HTREEITEM TVFindItemClass(HWND hTreeWnd, HTREEITEM hFirst, LPCTSTR classname)
{
	HTREEITEM hti;

	hti = hFirst;

	while(hti)
	{
		TV_ITEM tvi;

		tvi.mask = TVIF_PARAM;
		tvi.hItem = hti;

		if(!TreeView_GetItem(hTreeWnd, &tvi))
			_asm int 3;

		if(IsWindow((HWND)tvi.lParam))
		{
			char ts[64];
			GetClassName((HWND)tvi.lParam, ts, sizeof(ts));
			if(!lstrcmp(ts, classname))
				return hti;
		}

		if(TreeView_GetChild(hTreeWnd, hti))
		{
			HTREEITEM ret;

			ret = TVFindItemClass(hTreeWnd, TreeView_GetChild(hTreeWnd, hti), classname);

			if(ret)
				return ret;
		}

		hti = TreeView_GetNextSibling(hTreeWnd, hti);
	}

	return NULL;
}

COLORREF MixedColor(COLORREF cr1, COLORREF cr2, int per)
{
	struct c{
		BYTE r;
		BYTE g;
		BYTE b;
		BYTE a;
	};

	struct c c1 = *(struct c*)&cr1;
	struct c c2 = *(struct c*)&cr2;
	struct c r;

	r.r = (BYTE)(((int)c1.r * per + (int)c2.r * (100 - per)) / 100);
	r.g = (BYTE)(((int)c1.g * per + (int)c2.g * (100 - per)) / 100);
	r.b = (BYTE)(((int)c1.b * per + (int)c2.b * (100 - per)) / 100);

	return *(COLORREF*)&r;
}

BOOL CALLBACK wstoolDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static const LONG idcvsws[] = {
		IDC_WSPOPUP,		WS_POPUP,
		IDC_WSCHILD,		WS_CHILD,
		IDC_WSMINIMIZE,		WS_MINIMIZE,
		IDC_WSVISIBLE,		WS_VISIBLE,
		IDC_WSDISABLED,		WS_DISABLED,
		IDC_WSCLIPSIBLINGS,	WS_CLIPSIBLINGS,
		IDC_WSCLIPCHILDREN,	WS_CLIPCHILDREN,
		IDC_WSMAXIMIZE,		WS_MAXIMIZE,

		IDC_WSBORDER,		WS_BORDER,
		IDC_WSDLGFRAME,		WS_DLGFRAME,
		IDC_WSVSCROLL,		WS_VSCROLL,
		IDC_WSHSCROLL,		WS_HSCROLL,
		IDC_WSSYSMENU,		WS_SYSMENU,
		IDC_WSTHICKFRAME,	WS_THICKFRAME,
		IDC_WSGROUP,		WS_GROUP,
		IDC_WSTABSTOP,		WS_TABSTOP,
	};
	static const LONG idcvswsex[] = {
		IDC_WSEXDLGMODALFRAME,	WS_EX_DLGMODALFRAME,
		IDC_WSEXNOPARENTNOTIFY,	WS_EX_NOPARENTNOTIFY,
		IDC_WSEXTOPMOST,		WS_EX_TOPMOST,
		IDC_WSEXACCEPTFILES,	WS_EX_ACCEPTFILES,
		IDC_WSEXTRANSPARENT,	WS_EX_TRANSPARENT,
		IDC_WSEXMDICHILD,		WS_EX_MDICHILD,
		IDC_WSEXTOOLWINDOW,		WS_EX_TOOLWINDOW,
		IDC_WSEXWINDOWEDGE,		WS_EX_WINDOWEDGE,
		IDC_WSEXCLIENTEDGE,		WS_EX_CLIENTEDGE,
		IDC_WSEXCONTEXTHELP,	WS_EX_CONTEXTHELP,
		IDC_WSEXRIGHT,			WS_EX_RIGHT,
		IDC_WSEXRTLREADING,		WS_EX_RTLREADING,
		IDC_WSEXLEFTSCROLLBAR,	WS_EX_LEFTSCROLLBAR,
		IDC_WSEXCONTROLPARENT,	WS_EX_CONTROLPARENT,
		IDC_WSEXSTATICEDGE,		WS_EX_STATICEDGE,
		IDC_WSEXAPPWINDOW,		WS_EX_APPWINDOW,
		//IDC_WSEX,	WS_EX_,
		//IDC_WSEX,	WS_EX_,
	};

	switch(msg)
	{
	case WM_INITDIALOG:
		{
			LONG s, xs;

			SetWindowLong(hWnd, DWL_USER, (LONG)lParam);

			s = GetWindowLong((HWND)lParam, GWL_STYLE);
			xs = GetWindowLong((HWND)lParam, GWL_EXSTYLE);

			{
				int i;

				for(i = 0; i < sizeof(idcvsws) / sizeof(idcvsws[0]); i+=2)
				{
					SendDlgItemMessage(hWnd, idcvsws[i], BM_SETCHECK, s & idcvsws[i + 1] ? BST_CHECKED : BST_UNCHECKED, 0);
				}

				for(i = 0; i < sizeof(idcvswsex) / sizeof(idcvswsex[0]); i+=2)
				{
					SendDlgItemMessage(hWnd, idcvswsex[i], BM_SETCHECK, xs & idcvswsex[i + 1] ? BST_CHECKED : BST_UNCHECKED, 0);
				}
			}
		}
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			{
				LONG s, xs;
				int i;

				s = 0;
				for(i = 0; i < sizeof(idcvsws) / sizeof(idcvsws[0]); i+=2)
				{
					if(SendDlgItemMessage(hWnd, idcvsws[i], BM_GETCHECK, 0, 0))
						s |= idcvsws[i + 1];
				}

				xs = 0;
				for(i = 0; i < sizeof(idcvswsex) / sizeof(idcvswsex[0]); i+=2)
				{
					if(SendDlgItemMessage(hWnd, idcvswsex[i], BM_GETCHECK, 0, 0))
						xs |= idcvswsex[i + 1];
				}

				SetWindowLong((HWND)GetWindowLong(hWnd, DWL_USER), GWL_STYLE, s);
				SetWindowLong((HWND)GetWindowLong(hWnd, DWL_USER), GWL_EXSTYLE, xs);
			}
			EndDialog(hWnd, 0);
			return TRUE;
		case IDCANCEL:
			EndDialog(hWnd, 0);
			return TRUE;
		}
		break;
	}

	return FALSE;
}

BOOL CALLBACK MainDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			HDITEM hi;

			hi.mask = HDI_FORMAT | HDI_TEXT | HDI_WIDTH;
			hi.fmt = HDF_CENTER | HDF_STRING; 

			hi.pszText = TEXT("Title");
			hi.cxy = 150;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 0, (LPARAM)&hi);

			hi.pszText = TEXT("Class");
			hi.cxy = 150;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 1, (LPARAM)&hi);

			hi.pszText = TEXT("hWnd");
			hi.cxy = 70;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 2, (LPARAM)&hi);

			hi.pszText = TEXT("PID");
			hi.cxy = 50;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 3, (LPARAM)&hi);

			hi.pszText = TEXT("Style");
			hi.cxy = 70;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 4, (LPARAM)&hi);

			hi.pszText = TEXT("ExStyle");
			hi.cxy = 70;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 5, (LPARAM)&hi);

			hi.pszText = TEXT("Rgn");
			hi.cxy = 30;
			hi.cchTextMax = lstrlen(hi.pszText);
			SendMessage(GetDlgItem(hWnd, IDC_WNDTREEHEADER), HDM_INSERTITEM, 6, (LPARAM)&hi);
		}

		TreeViewSubProc(GetDlgItem(hWnd, IDC_WNDTREE), WM_APP, 0, 0);

		/*
		SendMessage(GetDlgItem(hWnd, IDC_WM), CB_SETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_ADDSTRING, 0, (LPARAM)TEXT("WM_CLOSE")), WM_CLOSE);
		SendMessage(GetDlgItem(hWnd, IDC_WM), CB_SETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_ADDSTRING, 0, (LPARAM)TEXT("WM_ENABLE")), WM_ENABLE);
		*/
		{
			int i;

			for(i = 0; i < sizeof(WMessages) / sizeof(struct tagWMessages); i++)
			{
				SendMessage(GetDlgItem(hWnd, IDC_WM), CB_SETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_ADDSTRING, 0, (LPARAM)WMessages[i].name), WMessages[i].msg);
			}
		}

		SendMessage(hWnd, WM_COMMAND, IDC_REFRESH, 0);

#ifdef _DEBUG
		SendMessage(GetDlgItem(hWnd, IDC_BLEND), TBM_SETRANGE, 1, MAKELPARAM(0, 100));
		SendMessage(GetDlgItem(hWnd, IDC_BLEND), TBM_SETPOS, 1, 50);
		ShowWindow(GetDlgItem(hWnd, IDC_BLEND), SW_SHOW);
#endif

		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDCANCEL:
			PostQuitMessage(0);
			//DeleteWindowRecursive(GetDlgItem(hWnd, IDC_WNDTREE), TreeView_GetRoot(GetDlgItem(hWnd, IDC_WNDTREE)));
			break;
		case IDC_REFRESH:
			TreeView_DeleteAllItems(GetDlgItem(hWnd, IDC_WNDTREE));
			AddWindowRecursive(GetDlgItem(hWnd, IDC_WNDTREE), TVI_ROOT, GetDesktopWindow());
			TreeView_Expand(GetDlgItem(hWnd, IDC_WNDTREE), TreeView_GetRoot(GetDlgItem(hWnd, IDC_WNDTREE)), TVE_EXPAND);
			break;
		case IDC_POSDBL:
			SetDlgItemInt(hWnd, IDC_POSX, GetDlgItemInt(hWnd, IDC_POSX, NULL, TRUE) * 2, TRUE);
			SetDlgItemInt(hWnd, IDC_POSY, GetDlgItemInt(hWnd, IDC_POSY, NULL, TRUE) * 2, TRUE);
			break;
		case IDC_POSHALF:
			SetDlgItemInt(hWnd, IDC_POSX, GetDlgItemInt(hWnd, IDC_POSX, NULL, TRUE) / 2, TRUE);
			SetDlgItemInt(hWnd, IDC_POSY, GetDlgItemInt(hWnd, IDC_POSY, NULL, TRUE) / 2, TRUE);
			break;
		case IDC_SETPOS:
			{
				TV_ITEM tvi;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				SetWindowPos((HWND)tvi.lParam, NULL, GetDlgItemInt(hWnd, IDC_POSX, NULL, TRUE), GetDlgItemInt(hWnd, IDC_POSY, NULL, TRUE), 0, 0, SWP_NOZORDER | SWP_NOSIZE);
			}
			break;
		case IDC_SIZEDBL:
			SetDlgItemInt(hWnd, IDC_SIZEX, GetDlgItemInt(hWnd, IDC_SIZEX, NULL, TRUE) * 2, TRUE);
			SetDlgItemInt(hWnd, IDC_SIZEY, GetDlgItemInt(hWnd, IDC_SIZEY, NULL, TRUE) * 2, TRUE);
			break;
		case IDC_SIZEHALF:
			SetDlgItemInt(hWnd, IDC_SIZEX, GetDlgItemInt(hWnd, IDC_SIZEX, NULL, TRUE) / 2, TRUE);
			SetDlgItemInt(hWnd, IDC_SIZEY, GetDlgItemInt(hWnd, IDC_SIZEY, NULL, TRUE) / 2, TRUE);
			break;
		case IDC_SETSIZE:
			{
				TV_ITEM tvi;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				SetWindowPos((HWND)tvi.lParam, NULL, 0, 0, GetDlgItemInt(hWnd, IDC_SIZEX, NULL, TRUE), GetDlgItemInt(hWnd, IDC_SIZEY, NULL, TRUE), SWP_NOZORDER | SWP_NOMOVE);
			}
			break;
		case IDC_CSIZEDBL:
			SetDlgItemInt(hWnd, IDC_CSIZEX, GetDlgItemInt(hWnd, IDC_CSIZEX, NULL, TRUE) * 2, TRUE);
			SetDlgItemInt(hWnd, IDC_CSIZEY, GetDlgItemInt(hWnd, IDC_CSIZEY, NULL, TRUE) * 2, TRUE);
			break;
		case IDC_CSIZEHALF:
			SetDlgItemInt(hWnd, IDC_CSIZEX, GetDlgItemInt(hWnd, IDC_CSIZEX, NULL, TRUE) / 2, TRUE);
			SetDlgItemInt(hWnd, IDC_CSIZEY, GetDlgItemInt(hWnd, IDC_CSIZEY, NULL, TRUE) / 2, TRUE);
			break;
		case IDC_SETCSIZE:
			{
				TV_ITEM tvi;
				RECT crc;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				crc.left = 0;
				crc.top = 0;
				crc.right = 0;
				crc.bottom = 0;

				AdjustWindowRectEx(&crc, GetWindowLong((HWND)tvi.lParam, GWL_STYLE), GetMenu((HWND)tvi.lParam) ? TRUE : FALSE, GetWindowLong((HWND)tvi.lParam, GWL_EXSTYLE));

				SetWindowPos((HWND)tvi.lParam, NULL, 0, 0, GetDlgItemInt(hWnd, IDC_CSIZEX, NULL, TRUE) + (crc.right - crc.left), GetDlgItemInt(hWnd, IDC_CSIZEY, NULL, TRUE) + (crc.bottom - crc.top), SWP_NOZORDER | SWP_NOMOVE);
			}
			break;
		case IDC_WNDSELECTOR:
			SendMessage(hWnd, WM_APP + 1, 0, 0);
			break;
		case IDC_WM:
			{
				int act;

				act = SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0);

				// TODO: SortƂ
				if(act == CB_ERR)
					SetDlgItemText(hWnd, IDC_WMDESC, TEXT(""));
				else
					SetDlgItemText(hWnd, IDC_WMDESC, WMessages[act].desc);
			}
			break;
		case IDC_SEND:
			{
				TV_ITEM tvi;
				UINT msg;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				if(SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0) != CB_ERR)
					msg = SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0), 0);
				else
					msg = GetDlgItemNum(hWnd, IDC_WM);

				//SendMessage((HWND)tvi.lParam, msg, GetDlgItemInt(hWnd, IDC_WP, NULL, FALSE), GetDlgItemInt(hWnd, IDC_LP, NULL, FALSE));
				SendMessage((HWND)tvi.lParam, msg, GetDlgItemNum(hWnd, IDC_WP), GetDlgItemNum(hWnd, IDC_LP));
			}
			break;
		case IDC_POST:
			{
				TV_ITEM tvi;
				UINT msg;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				if(SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0) != CB_ERR)
					msg = SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0), 0);
				else
					msg = GetDlgItemInt(hWnd, IDC_WM, NULL, FALSE);

				PostMessage((HWND)tvi.lParam, msg, GetDlgItemInt(hWnd, IDC_WP, NULL, FALSE), GetDlgItemInt(hWnd, IDC_LP, NULL, FALSE));
			}
			break;
		case IDC_REFRESHHK:
			{
				LRESULT key;

				UnregisterHotKey(hWnd, 0);
#define HK2RHK_MOD(key) ((HIBYTE(key) & HOTKEYF_SHIFT ? MOD_SHIFT : 0) | (HIBYTE(key) & HOTKEYF_CONTROL ? MOD_CONTROL : 0) | (HIBYTE(key) & HOTKEYF_ALT ? MOD_ALT : 0))
				key = SendMessage(GetDlgItem(hWnd, IDC_REFRESHHK), HKM_GETHOTKEY, 0, 0);
				if(LOBYTE(key) && !RegisterHotKey(hWnd, 0, HK2RHK_MOD(key), LOBYTE(key)))
				{
					MessageBox(hWnd, TEXT("Hotkey(Refresh) plant failed"), TEXT("Error"), MB_ICONERROR | MB_OK);
				}
			}
			break;
		case IDC_SENDHK:
			{
				LRESULT key;

				UnregisterHotKey(hWnd, 1);
				key = SendMessage(GetDlgItem(hWnd, IDC_SENDHK), HKM_GETHOTKEY, 0, 0);
				if(LOBYTE(key) && !RegisterHotKey(hWnd, 1, HK2RHK_MOD(key), LOBYTE(key)))
				{
					MessageBox(hWnd, TEXT("Hotkey(Send) plant failed"), TEXT("Error"), MB_ICONERROR | MB_OK);
				}
			}
			break;
		case IDC_WSTOOL:
			{
				TV_ITEM tvi;

				tvi.mask = TVIF_PARAM;
				if(!(tvi.hItem = TreeView_GetSelection(GetDlgItem(hWnd, IDC_WNDTREE))))
					break;
				TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi);

				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_WS), hWnd, wstoolDlgProc, tvi.lParam);
			}
			break;
		}
		break;
	case WM_HOTKEY:
		if(wParam == 0)
			SendMessage(hWnd, WM_COMMAND, IDC_REFRESH, 0);
		if(wParam == 1)
		{
			char ts[64];

			GetDlgItemText(hWnd, IDC_SENDCLASS, ts, sizeof(ts));
			if(lstrlen(ts))
			{
				HTREEITEM hti = TVFindItemClass(GetDlgItem(hWnd, IDC_WNDTREE), TreeView_GetRoot(GetDlgItem(hWnd, IDC_WNDTREE)), ts);

				if(hti)
				{
					TV_ITEM tvi;

					tvi.mask = TVIF_PARAM;
					tvi.hItem = hti;

					if(TreeView_GetItem(GetDlgItem(hWnd, IDC_WNDTREE), &tvi))
					{
						UINT msg;

						//wsprintf(ts, "%d", tvi.lParam);
						//MessageBox(hWnd, ts, NULL, 0);
						if(SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0) != CB_ERR)
							msg = SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETITEMDATA, SendMessage(GetDlgItem(hWnd, IDC_WM), CB_GETCURSEL, 0, 0), 0);
						else
							msg = GetDlgItemNum(hWnd, IDC_WM);

						SendMessage((HWND)tvi.lParam, msg, GetDlgItemNum(hWnd, IDC_WP), GetDlgItemNum(hWnd, IDC_LP));
					}else
						MessageBox(hWnd, "Specified Class Window Not Found", "wx: 404", MB_ICONERROR | MB_OK);
				}
			}
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR* nmh = (NMHDR*)lParam;

			switch(nmh->code)
			{
			/*
			case TVN_DELETEITEM:
				{
					NM_TREEVIEW* nmtv = (NM_TREEVIEW*)lParam;

					if(nmtv->itemOld.lParam)
						hfree((void*)nmtv->itemOld.lParam);
				}
				break;
			*/
			case TVN_SELCHANGED:
				{
					RECT rc, crc;
					TV_ITEM tvi;

					tvi.mask = TVIF_PARAM;
					tvi.hItem = ((NM_TREEVIEW*)lParam)->itemNew.hItem;
					TreeView_GetItem(((NM_TREEVIEW*)lParam)->hdr.hwndFrom, &tvi);

					GetWindowRect((HWND)tvi.lParam, &rc);

					SetDlgItemInt(hWnd, IDC_POSX, rc.left, TRUE);
					SetDlgItemInt(hWnd, IDC_POSY, rc.top, TRUE);
					SetDlgItemInt(hWnd, IDC_SIZEX, rc.right - rc.left, TRUE);
					SetDlgItemInt(hWnd, IDC_SIZEY, rc.bottom - rc.top, TRUE);

					crc.left = 0;
					crc.top = 0;
					crc.right = 0;
					crc.bottom = 0;

					AdjustWindowRectEx(&crc, GetWindowLong((HWND)tvi.lParam, GWL_STYLE), GetMenu((HWND)tvi.lParam) ? TRUE : FALSE, GetWindowLong((HWND)tvi.lParam, GWL_EXSTYLE));

					SetDlgItemInt(hWnd, IDC_CSIZEX, rc.right - rc.left - (crc.right - crc.left), TRUE);
					SetDlgItemInt(hWnd, IDC_CSIZEY, rc.bottom - rc.top - (crc.bottom - crc.top), TRUE);
					{
						char ts[64];

						GetClassName((HWND)tvi.lParam, ts, sizeof(ts));
						SetDlgItemText(hWnd, IDC_SENDCLASS, ts);
					}
				}
				break;
			case HDN_TRACK:	// HDS_FULLDRAGZbgĂȂ΁A
				{	// TrackĂƂ͍XVȂ悤Ȃ̂ŁAIɍXVB
					NMHEADER* nmx = (void*)lParam;	// NMHDR->NMHEADER
					HDITEM hdi;

					hdi = *nmx->pitem;
					hdi.mask = HDI_WIDTH;
					Header_SetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), nmx->iItem, &hdi);
				}
			case HDN_ENDTRACK:
				InvalidateRect(GetDlgItem(hWnd, IDC_WNDTREE), NULL, TRUE);
				break;
			case NM_CUSTOMDRAW:
				//DefWindowProc(hWnd, msg, wParam, lParam);
				{
					NMTVCUSTOMDRAW* tvcd = (NMTVCUSTOMDRAW*)lParam;

					if(tvcd->nmcd.hdr.hwndFrom == GetDlgItem(hWnd, IDC_WNDTREE))
					{
						switch(tvcd->nmcd.dwDrawStage)
						{
						case CDDS_PREPAINT:
							SetWindowLong(hWnd, DWL_MSGRESULT, CDRF_NOTIFYITEMDRAW);
							return TRUE;
						case CDDS_ITEMPREPAINT:
							//tvcd->clrText = RGB(255, 255, 255);
							//tvcd->clrTextBk = RGB(0, 0, 0);
							SetWindowLong(hWnd, DWL_MSGRESULT, CDRF_NOTIFYPOSTPAINT);
							return TRUE;
						case CDDS_ITEMPOSTPAINT:
							{
								RECT rc, wrc;
								TCHAR tx[256];
								HWND hTreeWnd = GetDlgItem(hWnd, IDC_WNDTREE);
								HWND hTargetWnd;

								{
									TV_ITEM tvi;

									tvi.mask = TVIF_PARAM;
									tvi.hItem = (HTREEITEM)tvcd->nmcd.dwItemSpec;
									TreeView_GetItem(hTreeWnd, &tvi);
									hTargetWnd = (HWND)tvi.lParam;
								}

								GetClientRect(hTreeWnd, &wrc);
								TreeView_GetItemRect(hTreeWnd, (HTREEITEM)tvcd->nmcd.dwItemSpec, &rc, TRUE);
								{
									HD_ITEM hdi;
									int i;

									rc.right = 0;

									hdi.mask = HDI_WIDTH;

									for(i = 0; i < Header_GetItemCount(GetDlgItem(hWnd, IDC_WNDTREEHEADER)); i++)
									{
										Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), i, &hdi);
										rc.right += hdi.cxy;
									}
								}

								if(tvcd->nmcd.uItemState & CDIS_SELECTED)
								{
									HPEN hp = SelectObject(tvcd->nmcd.hdc, CreatePen(PS_SOLID, 1, MixedColor(GetSysColor(COLOR_HIGHLIGHT) ^ 0xFFFFFF, GetSysColor(COLOR_WINDOW), 50)));
									HBRUSH hb;
									if(tvcd->nmcd.uItemState & CDIS_FOCUS)
#ifdef _DEBUG
										hb = SelectObject(tvcd->nmcd.hdc, CreateSolidBrush(MixedColor(GetSysColor(COLOR_HIGHLIGHT), GetSysColor(COLOR_WINDOW), SendMessage(GetDlgItem(hWnd, IDC_BLEND), TBM_GETPOS, 0, 0))));
#else
										hb = SelectObject(tvcd->nmcd.hdc, CreateSolidBrush(MixedColor(GetSysColor(COLOR_HIGHLIGHT), GetSysColor(COLOR_WINDOW), 50)));
#endif
									else
										hb = SelectObject(tvcd->nmcd.hdc, GetSysColorBrush(COLOR_WINDOW));

									Rectangle(tvcd->nmcd.hdc, rc.left, rc.top, rc.right, rc.bottom);

									DeleteObject(SelectObject(tvcd->nmcd.hdc, hb));
									DeleteObject(SelectObject(tvcd->nmcd.hdc, hp));
								}else
								{
									HPEN hp = SelectObject(tvcd->nmcd.hdc, GetStockObject(NULL_PEN));
									HBRUSH hb = SelectObject(tvcd->nmcd.hdc, GetSysColorBrush(COLOR_WINDOW));

									Rectangle(tvcd->nmcd.hdc, rc.left, rc.top, rc.right + 1, rc.bottom + 1);

									DeleteObject(SelectObject(tvcd->nmcd.hdc, hb));
									DeleteObject(SelectObject(tvcd->nmcd.hdc, hp));
								}

								if(tvcd->nmcd.uItemState & CDIS_FOCUS)
									SetTextColor(tvcd->nmcd.hdc, GetSysColor(COLOR_HIGHLIGHTTEXT));
								else
									SetTextColor(tvcd->nmcd.hdc, GetSysColor(COLOR_WINDOWTEXT));
								SetBkMode(tvcd->nmcd.hdc, TRANSPARENT);
								{
									RECT trc;
									HD_ITEM hdi;

									trc.left = rc.left + 2;
									trc.top = rc.top + 1;
									trc.right = rc.right;
									trc.bottom = rc.bottom;

									hdi.mask = HDI_WIDTH;

									GetWindowText(hTargetWnd, tx, sizeof(tx));
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 0, &hdi);
									trc.right = hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									trc.left = trc.right;
									GetClassName(hTargetWnd, tx, sizeof(tx));
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 1, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									trc.left = trc.right;
									wsprintf(tx, TEXT("0x%08X"), hTargetWnd);
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 2, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									// TODO: PID to EXENAME
									trc.left = trc.right;
									{
										DWORD pid;
										/*
										HANDLE hp;
										HMODULE mod;
										DWORD ret;

										TCHAR fn[MAX_PATH];
										*/

										GetWindowThreadProcessId(hTargetWnd, &pid);

										/*
										fn[0] = TEXT('\0');
										if(hp = OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, pid))
										{
											// TODO: EnumProcessModules AVAILABLE ONLY NT
											if(EnumProcessModules(hp, &mod, sizeof(mod), &ret))
												GetModuleFileName(mod, fn, sizeof(fn));
											CloseHandle(hp);
										}
										*/

										//if(!lstrlen(fn))
											wsprintf(tx, TEXT("%d"), pid);
										//else
										//	wsprintf(tx, TEXT("%d = %s"), pid, basename(fn));
									}
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 3, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									trc.left = trc.right;
									wsprintf(tx, TEXT("0x%08X"), GetWindowLong(hTargetWnd, GWL_STYLE));
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 4, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									trc.left = trc.right;
									wsprintf(tx, TEXT("0x%08X"), GetWindowLong(hTargetWnd, GWL_EXSTYLE));
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 5, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);

									trc.left = trc.right;
									{	// Sample from MSDN: "GetWindowRgn"
										HRGN hrgn = CreateRectRgn(0,0,0,0);

										lstrcpy(tx, "?");

										switch(GetWindowRgn(hTargetWnd, hrgn))
										{
										case ERROR:			lstrcpy(tx, "Err");	break;
										case NULLREGION:	lstrcpy(tx, "Nil");	break;	// What null rgn?
										case SIMPLEREGION:	lstrcpy(tx, "Sim");	break;
										case COMPLEXREGION:	lstrcpy(tx, "Cmp");	break;
										}

										DeleteObject(hrgn); /* [WgI */
									}
									Header_GetItem(GetDlgItem(hWnd, IDC_WNDTREEHEADER), 6, &hdi);
									trc.right = trc.left + hdi.cxy;
									DrawText(tvcd->nmcd.hdc, tx, lstrlen(tx), &trc, DT_LEFT | DT_VCENTER | DT_END_ELLIPSIS);
								}
							}
							SetWindowLong(hWnd, DWL_MSGRESULT, 0);
							return TRUE;
						}
					}
				}
				SetWindowLong(hWnd, DWL_MSGRESULT, 0);
				return TRUE;
			}
		}
		break;


	case WM_APP + 1:
		SetCursor(LoadCursor(NULL, IDC_CROSS));
		SetCapture(hWnd);
		SetWindowLong(hWnd, DWL_USER, 0);

		SendMessage(hWnd, WM_MOUSEMOVE, 0, 0);

		break;
	case WM_MOUSEMOVE:
		if(GetCapture() == hWnd)
		{
			POINT p;
			HWND hw, oldhw;

			GetCursorPos(&p);
			hw = WindowFromPoint(p);
			oldhw = (HWND)GetWindowLong(hWnd, DWL_USER);

			/*
			while(GetWindowLong(hw, GWL_STYLE) & WS_CHILD)
			{
				hw = GetParent(hw);
			}
			*/

			if(oldhw != hw)
			{
				if(oldhw)
					waku(oldhw);
				waku(hw);
				SetWindowLong(hWnd, DWL_USER, (LONG)hw);

				//TreeView_GetNext
				// Find LParam == hw, select it.
				if(GetAsyncKeyState(VK_SHIFT) & 0x8000)
				{
					HTREEITEM chosen = TVFindItemParam(GetDlgItem(hWnd, IDC_WNDTREE), TreeView_GetRoot(GetDlgItem(hWnd, IDC_WNDTREE)), (LPARAM)hw);
					if(chosen)
						TreeView_SelectItem(GetDlgItem(hWnd, IDC_WNDTREE), chosen);
				}

				/*
				{
					TCHAR tx[64];

					wsprintf(tx, TEXT("0x%08X"), hw);
					SetDlgItemText(hWnd, IDC_HWND, tx);
				}
				*/
			}
		}
		break;
	case WM_LBUTTONUP:
		if(GetCapture() == hWnd)
		{
			HWND hw;

			SetCursor(LoadCursor(NULL, IDC_ARROW));
			ReleaseCapture();

			hw = (HWND)GetWindowLong(hWnd, DWL_USER);

			{	// Select selected window
				HTREEITEM chosen = TVFindItemParam(GetDlgItem(hWnd, IDC_WNDTREE), TreeView_GetRoot(GetDlgItem(hWnd, IDC_WNDTREE)), (LPARAM)hw);
				if(chosen)
					TreeView_SelectItem(GetDlgItem(hWnd, IDC_WNDTREE), chosen);
			}

			if(hw)
			{
				waku(hw);
			}
		}
		break;


	}

	return FALSE;
}

void WinMainCRTStartup(void)
{
	DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlgProc, 0);

	ExitProcess(0);
}
